#include <stdio.h>
#include <stdlib.h>
#include <string.h>


int explz(unsigned char *dest, int dest_size, unsigned char *src, int src_size){
	unsigned char *src_ptr;
	unsigned char *dest_ptr;
	unsigned char dic[4096];
	int ofs;
	int len;
	int flag;
	int dic_ofs;

	src_ptr = src;
	dest_ptr = dest;
	flag = 0;
	dic_ofs = (4096 - 18);
	memset(dic, 0, 4096);


	while(src_size > 0){
		if(dest_size <= 0){
			break;
		}

		if((flag & 0xFF00) == 0){
			flag = (*src_ptr);
			src_ptr += 1;
			src_size -= 1;
			flag |= 0xFF00;
		}

		if((flag & 1) == 0){
			ofs = (*src_ptr);
			src_ptr += 1;
			len = (*src_ptr);
			src_ptr += 1;
			src_size -= 2;
			ofs |= ((len & 0xF0) << 4);
			len = ((len & 0x0F) + 3);
			dest_size -= len;
			while(len > 0){
				(*dest_ptr) = dic[ofs];
				dest_ptr += 1;
				dic[dic_ofs] = dic[ofs];
				ofs = ((ofs + 1) & 0x0FFF);
				dic_ofs = ((dic_ofs + 1) & 0x0FFF);
				len -= 1;
			}
		}
		else{
			(*dest_ptr) = (*src_ptr);
			dic[dic_ofs] = (*src_ptr);
			dest_ptr += 1;
			src_ptr += 1;
			src_size -= 1;
			dest_size -= 1;
			dic_ofs = ((dic_ofs + 1) & 0x0FFF);
		}
		flag >>= 1;
	}

	return (dest_ptr - dest);
}




int main(int argc, char *argv[]){
	char *src_name;
	char dest_name[64];
	unsigned char *src_data;
	unsigned char *dest_data;
	int src_size;
	int dest_size;
	FILE *fp;
	int m;

	src_name = NULL;
	dest_name[0] = '\0';

	m = 1;
	while(m < argc){
		if(src_name == NULL){
			src_name = argv[m];
		}
		else if(dest_name[0] == '\0'){
			strcpy(dest_name, argv[m]);
		}
		m += 1;
	}

	if(src_name == 0){
		return 0;
	}

	if(dest_name[0] == '\0'){
		dest_name[0] = '_';
		dest_name[1] = '\0';
		strcat(dest_name, src_name);
	}

	fp=fopen(src_name, "rb");
	if(fp == NULL)
		return 1;
	fseek(fp, 0, SEEK_END);
	src_size = ftell(fp);
	fseek(fp, 0, SEEK_SET);
	src_data = (unsigned char*)malloc(src_size);
	if(src_data == NULL){
		fclose(fp);
		return 1;
	}
	fread(src_data, 1, src_size, fp);
	fclose(fp);

	dest_data = (unsigned char*)malloc(0x10000);
	if(dest_data == NULL){
		free(src_data);
		return 1;
	}

	dest_size = explz(dest_data, (src_data[0] | (src_data[1] << 8)), (src_data + 4), (src_size - 4));

	fp = fopen(dest_name, "wb");
	if(fp != NULL){
		fwrite(dest_data, 1, dest_size, fp);
		fclose(fp);
	}

	free(dest_data);
	free(src_data);

	return 0;
}
